function observer_design(a,b,c,d,cp,op,xo,xho,t)

% The functioon requires: a,b,c,d, cp (controller poles),
%  op (observer poles), xo (system initial conditions), 
%  xho (observer initial conditions), t (time axis)

k = place(a,b,cp); % state feedback
l = place(a',c',op); l = l'; % observer feedback vector
ak = a-b*k-l*c-l*d*k; bk=l; ck=k; % observer system
ac = a-b*k; bc =b;cc = c; dc = d; % state feedback system

% If d is a scalar and d=0, zeros(d) will produce an error.
% Next line prevents this.
[tmp1,tmp2] = size(d); dk = zeros(tmp1,tmp2);

[zK,pK,gainK] = ss2zp(ak,bk,ck,dk,1);
disp(' The compensator poles are '); pK
disp( 'the compensator zeroes are ');zK
[agk,bgk,cgk,dgk] = series(a,b,c,d,ak,bk,ck,dk);
f1 = figure('Name', 'Root locus');
f2 = figure('Name', 'x_1');
f3 = figure('Name', 'x_2');
f4 = figure('Name', 'x_3');
f5 = figure('Name', 'Bode plot');
f6 = figure('Name', 'Step response');
figure(f5);
[mc,pc,w] = bode(agk,bgk,cgk,dgk,1);
bode(agk,bgk,cgk,dgk,1)
grid on
[gm,pm,wpc,wgc] = margin(mc,pc,w);
figure(f1);
rlocus(agk,bgk,cgk,dgk)
grid on
[at,bt,ct,dt] = feedback(a,b,c,d,ak,bk,ck,dk);
[zT,pT,gainT] = ss2zp(at,bt,ct,dt,1);
disp( 'the closed loop poles are  '); pT
disp( 'the closed loop zeroes are  '); zT
yc = step(at,bt,ct,dt,1,t);
yt = step(ac,bc,cc,dc,1,t);
figure(f6);
%step(ac,bc,cc,dc,1,t)
dcg = dcgain(at,bt,ct,dt);
dcgc = dcgain(ac,bc,cc,dc);
yc = yc/dcg;
ycc = yt/dcgc;
plot(t,yc,'--',t,ycc)
legend('Observer output','Regulator output')
tit = ('$y(t)$ and $\hat{y}(t)$');
title(tit,'interpreter','latex')
grid on
% plot states and their estimates
[ata,bta,cta,dta] = augstate(at,bt,ct,dt);
t2 = [0:0.02:10]';
x_xh = initial(ata,bta,cta,dta,[xo xho],t2);
x = x_xh(:,2:4); xh = x_xh(:,5:7);
figure(f2);
plot(t2,[x(:,1) xh(:,1)])
legend('x1','xo1')
tit = ('State $x_1(t)$ and observer estimate $\hat{x}_1(t)$');
title(tit,'interpreter','latex')
grid on
figure(f3);
plot(t2, [x(:,2) xh(:,2)])
legend('x2','xo2')
tit = ('State $x_2(t)$ and observer estimate $\hat{x}_2(t)$');
title(tit,'interpreter','latex')
grid on
figure(f4);
plot(t2,[x(:,3) xh(:,3)])
legend('x3','xo3')
tit = ('State $x_3(t)$ and observer estimate $\hat{x}_3(t)$');
title(tit,'interpreter','latex')
grid on

