function [k,mc,pc] = state_fb(a,b,c,d,cp,t)

%   The function requires a,b,c,d, closed loop poles(cp),
%       and timeline(t)
%   The function returns an array of the state feedback
%       coefficients, and two arrays of magnitude and phase
%       of the Bode graph, respectively. 
%   The feedback design is performed within the first three lines.
%   Depending of user needs the rest of the function
%       may be properly modified.

disp('  The open loop zeroes and poles are')
[olz,olp,olg]=ss2zp(a,b,c,d)
k=place(a,b,cp);
[mc,pc]=bode(a,b,k,0,1);
%bode(a,b,k,0,1);
%rlocus(a,b,k,0)
at=a-b*k;bt=b;ct=c;dt=d; 
[zT,pT,gainT]=ss2zp(at,bt,ct,dt);
dcg=dcgain(at,bt,ct,dt);
yc=step(at,bt,ct,dt,1,t);
step(at,bt,ct,dt,1,t)
yc=yc/dcg;
end